/**********************************************************************
 * $Id: UniqueCoordinateArrayFilter.cpp,v 1.4 2003/11/07 01:23:43 pramsey Exp $
 *
 * GEOS - Geometry Engine Open Source
 * http://geos.refractions.net
 *
 * Copyright (C) 2001-2002 Vivid Solutions Inc.
 *
 * This is free software; you can redistribute and/or modify it under
 * the terms of the GNU Lesser General Public Licence as published
 * by the Free Software Foundation. 
 * See the COPYING file for more information.
 *
 **********************************************************************
 * $Log: UniqueCoordinateArrayFilter.cpp,v $
 * Revision 1.4  2003/11/07 01:23:43  pramsey
 * Add standard CVS headers licence notices and copyrights to all cpp and h
 * files.
 *
 *
 **********************************************************************/


#include "../headers/util.h"
#include "../headers/geom.h"

namespace geos {
UniqueCoordinateArrayFilter::UniqueCoordinateArrayFilter() {
	list=CoordinateListFactory::internalFactory->createCoordinateList();
}
UniqueCoordinateArrayFilter::~UniqueCoordinateArrayFilter() {
	delete list;
}
/**
*  Returns the gathered <code>Coordinate</code>s.
*
*@return    the <code>Coordinate</code>s collected by this <code>CoordinateArrayFilter</code>
*/
const CoordinateList* UniqueCoordinateArrayFilter::getCoordinates() const {
	return list;
}

void UniqueCoordinateArrayFilter::filter_ro(const Coordinate &coord) {
	if (CoordinateList::indexOf(&coord,list)==-1) {
		list->add(coord);
	}
}

void UniqueCoordinateArrayFilter::filter_rw(Coordinate &coord) {
	throw new UnsupportedOperationException("UniqueCoordinateArrayFilter is a read-only filter");
}

}

